# EventSourcery::EventStore

The implementation of the popular Greg Young's [EventStore](https://eventstore.org) that makes it possible to use it together with:

- Envato's [event_sourcery](https://github.com/envato/event_sourcery) as the primary tool for implementing CQRS / event sourced applications
- Envato's [event_sourcery-postgres](https://github.com/envato/event_sourcery-postgres) for projections and other supporting thing (optional)


## Installation

Add this line to your application's Gemfile:

```ruby
gem 'event_sourcery-event_store'
```

And then execute:

    $ bundle

## Usage


Configure how to talk to EventStore

```ruby
EventSourcery::EventStore.configure do |config|
  config.event_store_base_uri = "https://location-of-eventstore:2113"
end
```

Optionally, configure [event_sourcery-postgres](https://github.com/envato/event_sourcery-postgres) for projections.
**NOTE:** Make sure it, it is NOT used as an event store!
**NOTE:** If you do not use `event_sourcery-postgres`, then you'll need to choose your own implementation (`event_sourcery` comes with built-in in-memory implementation).

```ruby
EventSourcery::EventStore.configure do |config|
  config.event_store_base_uri = "https://location-of-eventstore:2113"
end
```


Start working on your app - [see the documentation](https://github.com/envato/event_sourcery) and an [example-app](https://github.com/envato/event_sourcery_todo_app).


## Development

```bash
bin/setup
bundle exec rspec

# can run interactive consolve to experiment
bin/console
```

To install this gem onto your local machine, run `bundle exec rake install`.

To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`,
which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/flipgroup/event_sourcery-event_store. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the EventSourcery::EventStore project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/flipgroup/event_sourcery-event_store/blob/master/CODE_OF_CONDUCT.md).
